\NeedsTeXFormat{LaTeX2e}
\listfiles

\documentclass[12pt,a4paper,twoside]{article}
\usepackage{graphics,epsfig}
\usepackage[latin1]{inputenc}
\usepackage{alltt,color,xcolor}
\usepackage{xypic}
\usepackage{amsfonts,amssymb,amsmath}
\usepackage{wrapfig}
\usepackage{ocamldoc}


\setlength{\textwidth}{161mm} %21cm - (2 * 1in)
\setlength{\textheight}{224mm}
\setlength{\oddsidemargin}{0pt}
\setlength{\evensidemargin}{0pt}
\setlength{\topmargin}{0pt}

\newcommand{\lucky}{{\tt Lucky}}
\newcommand{\lurettetop}{{\tt lurettetop}}
\newcommand{\xlurette}{{\tt Xlurette}}
\newcommand{\lutin}{{\tt Lutin}}
\newcommand{\genfake}{{\tt gen\_fake\_lutin}}
\newcommand{\showluc}{{\tt show\_luc}}
\newcommand{\eps}{\varepsilon}
\newcommand{\ind}{\hspace{2cm}}


\newcommand{\op}{$\langle$}
\newcommand{\cl}{$\rangle$}

\newcommand{\semce}[2]{\[#1\] \ #2}
\newcommand{\semtest}[3]{\[${\tt #1}$ #2\]_t \ #3}

\newcommand{\alors}{{$\rightarrow \ $}}
\newcommand{\fleche}{{\rightarrow}}
\newcommand{\term}[1]{{\color{blue3} \tt#1}}
\newcommand{\code}[1]{{\tt#1}}
\newcommand{\metaterm}[1]{#1}
\newcommand{\nt}[1]{{\color{green4} \tt {<}}{\color{green4} \bf#1}{\color{green4} \tt {>}}}
\def\int{\nt{int}}
\def\float{\nt{float}}
\def\bool{\nt{bool}}
\def\ident{\nt{ident}}
%\newcommand{\identt}[1]{{\green \tt {<}}{\green \bf ident$_{#1}$}{\green \tt {>}}}
\newcommand{\identt}[1]{{\color{green4} \tt {<}}{\color{green4}\bf ident{\color{green4} \tt {>}}}}
\def\preident{\nt{pre}}
\def\nodes{\mathcal{N}}
\def\trans{\mathcal{T}}
\def\graph{\mathcal{G}}


\def\mnodes{$\mathcal{N}$}
\def\mtrans{$\mathcal{T}$}
\def\mgraph{$\mathcal{G}$}

% CROCHET BIZARRE
\def\[{\normalfont{\mbox{[\hspace{-.35ex}[}}}
\def\]{\normalfont{\mbox{]\hspace{-.35ex}]}}}

\newcommand{\WTS}{\mbox{Lucky programs}}
\newcommand{\usmms}{Lucky programs}
\newcommand{\usmm}{Lucky programs}
\newcommand{\USMM}{Lucky programs}
\newcommand{\pre}{\bullet}
\newcommand{\lurette}{\mbox{\sc Lurette}}
\newcommand{\lustre}{\mbox{\sc Lustre}}


\newcommand{\simpletrans}[1]{
\raisebox{-1ex}{$\stackrel{\scriptstyle #1}\longrightarrow$}
}
\newcommand{\transition}[2]{
\raisebox{-1ex}{$\stackrel{\scriptstyle #1}{\stackrel{\longrightarrow}{\scriptstyle #2}}$}
}
\newcommand{\microstep}[2]{
\raisebox{-1ex}{$\stackrel{\scriptstyle #1}{\stackrel{\; \longmapsto}{\scriptstyle #2}}$}
}
\newcommand{\seqmicrostep}[2]{
\raisebox{-1ex}{$\stackrel{\scriptstyle #1}{\stackrel{\; \longmapsto^*}{\scriptstyle #2}}$}
}
\newcommand{\macrostep}[2]{
\raisebox{-1ex}{$\stackrel{\scriptstyle #1}{\stackrel{|\!\Longrightarrow}{\scriptstyle #2}}$}
}
\newcommand{\cpt}{\mbox{$j$}}
\newcommand{\Sopen}{\footnotesize $S_{\mbox{\tiny open}}$}
\newcommand{\Son}{\footnotesize $S_{\mbox{\tiny on}}$}
\newcommand{\Soff}{\footnotesize $S_{\mbox{\tiny off}}$}

\newcommand{\jeOon}{\footnotesize $\bullet j=0 \wedge On$}
\newcommand{\jeOnoton}{\footnotesize $\bullet j=0 \wedge \neg On$}
\newcommand{\jsOand}{\footnotesize $\bullet j>0 \wedge$}
\newcommand{\jmI}{\footnotesize $j=\bullet j-1$}
\newcommand{\jint}{\footnotesize $10 \le j \le 15$}
\newcommand{\tdef}{\footnotesize $t=\frac{3\bullet t+T}{4}$}

\newcommand{\deltapos}{\footnotesize $0<\delta<0.2$}

\newcommand{\tdelta}{\footnotesize $t=\bullet t+\delta \wedge$}

\newcommand{\deltaneg}{\footnotesize $-0.1<\delta<0$}

\newcommand{\fon}{\footnotesize $On$}
\newcommand{\fnoton}{\footnotesize $\neg On$}
 
\newcommand{\pce}{\tiny {\it 100}}

%%%% debut macro %%%%
% I like to put boxes around all of my figures and algorithms in
% reports, and finally came up with my 'bigbox' environment.  It
% makes a box as wide as the current text and sets the stuff
% inside with a narrower width.
%
% USAGE:
%
% \begin{figure}        (or {table}, or {center}, or ...)
%   \begin{bigbox}
%     \begin{tabbing}
%       ...
%     \end{tabbing}
%   \end{bigbox}
%   \caption{XXX}
% \end{figure}
%
%%% BIGBOX - environment
%%%
%%% TOM SHEFFLER
%%% Carnegie Mellon, Aug 1990
%%%
%%% Make an environment for boxing a figure and setting it in
%%% a narrower width.
\newdimen\boxfigwidth % width of figure box

\def\bigbox{\begingroup
  % Figure out how wide to set the box in
  \boxfigwidth=\hsize
  \advance\boxfigwidth by -2\fboxrule
  \advance\boxfigwidth by -2\fboxsep
  \setbox4=\vbox\bgroup\hsize\boxfigwidth
  % Make an invisible hrule so that the box is exactly this wide
  \hrule height0pt width\boxfigwidth\smallskip%
% Some environments like TABBING and other LIST environments
% use this measure of line size - \LINEWIDTH=\HSIZE-\LEFTMARGIN-\RIGHTMARGIN?
  \linewidth=\boxfigwidth
}
\def\endbigbox{\smallskip\egroup\fbox{\box4}\endgroup}
%%%% fin macro %%%%


%\input{commandes.tex}

%\gdef\SetFigFont#1#2#3#4#5{}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{document}  
%\pdfpagewidth= 21cm
%\pdfpageheight= 29.7cm


\begin{center}

{\large \bf IST-2001-34363 }\\
\rule{4cm}{1pt}\\[8mm]


{\large 
Advanced Design Tools for Safety Critical Systems

SAFEAIR II 
}

\vfill

\includegraphics{logo-ist.jpg}

\vfill

\rule{4cm}{1pt}\\[8mm]
{\Large \bf Deliverable D1.1}\\[10mm]
{\Large \bf Test Tool Specification}\\[5mm]
\rule{4cm}{1pt}\\[8mm]



\vfill

\end{center}

\vfill

{\bf Responsible: } Nicolas Halbwachs (\emph{Verimag})\\

{\bf Issued by: } Nicolas Halbwachs and Erwan Jahier (\emph{Verimag})\\


{\bf Abstract: } 
Lurette is an Automatic Test Generator (ATG) for reactive programs
written in Lustre or Scade. It is automated in two main ways: it
automatically generates input values to the system under test by
randomly draw among the solutions satisfying the system environment
properties.  The test results perusal is also automated; users simply
need to specify in Lustre or Scade the properties that should be
fulfilled by their program outputs.

In this document, after a brief outline of Lurette principles, we 
provide the specification of the Lurette tool.



\newpage 
\tableofcontents
 
\newpage 
\section{Introduction}

The testing tool which is under adaptation --- in fact, under redesign --- in the
framework of the project, is called Lurette, and is based on the principles
described in \cite{lurette98}. We first recall those principles, before 
presenting the specifications of the new tool.

\subsection{What kind of testing?}
Of course, formal verification should be used whenever possible.
However, because program verification is undecidable, testing will
always be necessary. In this work we concentrate on cases where
formal verification cannot be applied, i.e.,
\begin{itemize}
\item for complex programs and properties, involving numerical aspects
\item for black-box programs, (a part of) the source of which is not available or
written in a low level language.
\end{itemize}

The last point means that Lurette will focus on functional testing:
the program will be a black box, for which we want to check some
properties.

\subsection{Testing reactive systems: specific problems}

In addition to usual problems of test case generation --- selection of realistic
test cases, oracle and diagnosis, defining and improving coverage ---, testing 
reactive systems  raises some specific problems:
\begin{itemize}
\item test cases are not just input values, but {\em sequences\/} of input values,
and these sequences can be very long.
\item a reactive system is often intended to control its environment. As a
consequence, realistic test sequences can depend on the behaviour of the system
under test (SUT). More precisely, the selection of an input value, at a given
sequence point, can depend on the reaction (previous outputs) of the SUT to the
previous elements of the sequence. Hence, realistic sequences cannot be generated
off-line, and the SUT must be involved in the generation.
\end{itemize}

\subsection{Testing reactive systems: the proposed solution}
In \cite{lurette98}, we propose to generate test sequences from a
user-given specification of realistic (or ``interesting'') scenarios.
Such specification, say $\Sigma$ is a non deterministic description
of sequences involving both input ($I$, to be generated by the tool)
and output ($O$, computed from $I$ by the SUT) variables of the SUT.
The only restriction is that the constraints on inputs $I$, at a
given point of a sequence, may only depend on the {\em past} values
of outputs $O$. Moreover, the user can also provide another
specification, say $\Omega$, of the same kind as $\Sigma$, which
describes correct behaviours or desired properties of the SUT.

The tool generates input sequences as follows: it first uses $\Sigma$
to randomly select a first input vector $i$ satisfying the
specification; then it provides the vector to the SUT for one
reaction, and gets back the corresponding output vector $o$; $i$ and
$o$ are checked against the oracle $\Omega$; then the internal state
of $\Sigma$ and $\Omega$ are updated according to $i$ and $o$, and a
new step can start.

\subsection{Description of non-deterministic behaviours}

An important point is the way behaviours are specified. Basically,
such a specification should behave as an automaton, providing
constraints on $I$ according to its internal state, and moving from
state to state according to the current values of $I$ and $O$. In the
previous version of Lurette, this specification was just an observer
written in Lustre. In the new version, we want to allow various
formalisms for that, because Lustre observers are neither always
convenient, nor powerful enough: for instance, it is often
interesting to drive the generation using weights or probabilities.
This why the tool is organised around an internal format, called
Lucky, into which the user's formalisms are intended to be
translated.


\subsection{Plan}

In the following, we specify the Lurette tool in a top-down manner.
First of all, we specify in Section~\ref{lurette-func} the Lurette
functionalities, from the user point of view. 
%
Then, in Section~\ref{lurette-components}, we specify, at a
relatively high-level, the different components the Lurette tool will
be made of, and how those components are  used by each other.
%
%
Finally, we specify the Lurette architecture by providing the main
module interfaces and their dependencies in
Section~\ref{lucky-interfaces}. 

A more refined description of those
modules signatures is also provided in
Appendix~\ref{lurette-detailled}.
%
In Appendix~\ref{lucky-section}, we specify the Lucky language, that
lets one describe and simulate the SUT environment. Note, that Lucky
is truly the central part of this ATG tool, and its execution model
represents probably most of the design and implementation effort of
the new Lurette.



\newpage 
\section{Lurette functionalities -- The User point of view}
\label{lurette-func}




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
\subsection[Lucky: a language to describe and simulate the SUT Environment]{Lucky: a language to describe and simulate the System Under Test (SUT) Environment}

\paragraph{SUT Input sequence generation.}

The main challenge to automate the testing process is to able able to
automate the generation of \emph{realistic} input sequences to feed
the SUT. In other words, we need an executable model of the
environment which inputs are the SUT outputs, and which outputs are
the SUT inputs. 


Note that realistic input sequences can not be generated off-line,
since the SUT generally influences the behaviour of the environment it
is supposed to control, and vice-versa. Imagine, for example, a
heater controller which input is the temperature in the room, and
which output is a Boolean signal telling the heater whether to heat
or not.

In the first Lurette prototype, the SUT environment behaviour was
described by Lustre observers which were specifying what realistic
SUT inputs should be. In other words, the environment was modelled by
a set of (linear) constraints over Boolean and numeric variables.
The work of Lurette was to solve those constraints, and to draw a
value among the solutions to produce one SUT input vector.

But, from a language expressing power point of view, Lustre observers
happen to be too restrictive, in particular to express sequences of
different testing scenarios, or to have some control on the
probabilistic distribution of the drawn solution.  It was precisely
to overcome those limitations that a new language, Lucky, was
designed. 


\paragraph{The Lucky language.}
A Lucky program is an automaton whose transitions define the
reactions of the machine. More precisely, each transition is
associated to (1) a set of constraints (a formula) that defines the
set of the possible outputs, and (2) a weight that defines the
relative probability for each transitions to be taken (i.e., to be used
to produce the output vector for the current step).
%
%
The Lucky syntax and semantics is given in
Section~\ref{lucky-section}.

\paragraph{Other Simulation Languages.}
One of the goal when designing Lucky was to have a language with a
simple operational semantics (it is a simple interpreted automaton)
that is sufficiently general to model any non-deterministic formal
description. In particular, we have designed another language,
Lutin~\cite{lutin-slap}, which compiles into Lucky.  Lutin also aims at
describing and simulating non-deterministic systems, but it is based on
regular expressions instead of an explicit automaton, which generally
makes the description of non-deterministic systems easier.
%
Lutin will not be further described in this document.

Moreover, a gateway from Lustre observers to Lucky programs can
easily be done: it will result in a somewhat degenerated Lucky
automaton with one control state and one (looping) transition labelled
by the Lustre observer equations.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
\subsection{The Test Oracle}

The second thing that needs to be automated in the testing process is
the test result perusal. In other words, we need to be able to decide
automatically whether or not the test succeeded. To do that, we will
use exactly the same technique as in the first Lurette prototype:
namely, via the use of Lustre observers.  Users need to write a
Lustre (or a Scade) program which inputs are the SUT inputs and
outputs, and which output is a single Boolean that is true if and
only if the test vectors are correct w.r.t. a given property. That
property can be, for example, a property that a verification tool
failed to prove (which precisely when testing
techniques are necessary).




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
\subsection{The Lurette testing process}
We recall now how the different entities (SUT, oracle, environment)
work all together inside the Lurette automated test generation (ATG) tool.



\begin{wrapfigure}{r}{6cm}
%\vspace{-2cm}
  \mbox{ \scalebox{.45}{\input{objs/lurette-start}}}
  \caption{Lurette start-up}
  \label{lurette-start}
\end{wrapfigure}



Figure~\ref{lurette-start} shows up what happens when Lurette starts
up. The idea is that environment outputs serve as SUT inputs, and SUT
outputs serve as environment inputs (the first step excepted). In
order to be able to start such a looped design, one entity have to
start first.  The choice has been made that the environment will.
This means that a sensible environment for Lurette is one that can
generate values without any input at time 1.

The role of {\tt boot} keyword of Figure~\ref{lurette-start} is
precisely to indicate that the environment is indeed starting first;
once the environment received the {\tt boot} signal, it
(non-deterministically) produces an output vector $I$, which will be
used by the SUT. $try / I$ means that once one step is done in the
SUT to compute its output $O$, the previous state of the SUT is
immediately restored. This allows several input vectors $I$ to be
tried at each step, to perform a kind of \emph{thick} test. In
Figure~\ref{lurette-start}, the different tries are distinguished
thanks to the index  $i$. Hence, at the $i^{th}$ tries, the
vectors $I_i$ and $O_i$, respectively produced by the environment and
the SUT, are tried in the oracle. 



\begin{figure}[h]
 \begin{minipage}{0.5\textwidth}
  \mbox{ \scalebox{.45}{\input{objs/lurette-step}}}
  \caption{Lurette steps \label{lurette-step}}
\end{minipage}
%
 \begin{minipage}{0.5\textwidth}
  \mbox{ \scalebox{.5}{\input{objs/lurette-try}}}
  \caption{Lurette tries}
  \label{lurette-try}
\end{minipage}

\end{figure}


% \begin{wrapfigure}[7]{l}{7cm}
%   \mbox{ \scalebox{.5}{\input{lurette-step.pstex_t}}}
%   \caption{Lurette steps \label{lurette-step}}
% \end{wrapfigure}
% %
% \begin{wrapfigure}[0]{r}{7cm}
%   \mbox{ \scalebox{.5}{\input{lurette-try.pstex_t}}}
%   \caption{Lurette tries}
%   \label{lurette-try}
% \end{wrapfigure}




Once a sufficient number of tries has been done (the thickness of
the test is one of the Lurette parameters users have control on, (cf.
Section~\ref{test-parameters}), one index is chosen, say $j$, and the
step corresponding to that index is really\footnote{is the sense that
  the previous state of machines is not restored this time.} done
(Figure~\ref{lurette-step}). Note that since the SUT and the oracle
are deterministic machines, we just need to give them the vector
$I_j$ and $O_j$ once more. But this is not true for the environment,
which is non-deterministic; that is the reason why we give it the index
$j$; of course, this means that the environment interpreter needs to
remember which index leads to which internal state.



% \begin{wrapfigure}[4]{r}{7cm}
%   \mbox{ \scalebox{.5}{\input{lurette-try.pstex_t}}}
%   \caption{Lurette tries}
%   \label{lurette-try}
% \end{wrapfigure}



Then the process continues as in Figure~\ref{lurette-start}; the only
difference, as shown in Figure~\ref{lurette-try}, is that the
environment is fed with the SUT output vector $O_j$ which was
elected at the previous step (instead of {\tt boot i}).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
\subsection{The Test Parameters}
\label{test-parameters}
In addition to the obvious Lurette parameters, which are the file
names of the SUT, its environment, and the oracle (optional), users should be
able to change the following parameters.

\paragraph{The Test Length.}

The Test Length is the number of steps that should be generated.

\paragraph{The Draw Mode.}

The Draw Mode is the policy that is used draw solutions for numeric
variables (integers or reals). Indeed, since the constraints on such
variables are linear, their solutions can be represented by unions of
convex polyhedra. But, once those polyhedra are computed, several
interesting drawing policies are possible:

\begin{itemize}
\item drawing among vertices;
\item drawing on the edges;
\item draw uniformly inside.
\end{itemize}

\paragraph{The Test Thickness.}

The Test Thickness is the number of tries we perform at each step.
At each step, several transitions might be tried, and, for each set
of solutions corresponding to each path in the automaton, several
points might by tried. Different thicknesses can be associated for
each drawing policy (vertices, edges, inside).






\subsection{Lurette in action}
\label{running-example}

Suppose one want to test a heater controller which has 3 sensors
(namely, 3 reals inputs) measuring the temperature in a room, and
which returns a Boolean which indicates to the heater whether it
should heat or not.


We propose to model a possible environment for that controller with
the lucky automata of Figure~\ref{heater-sensors}.  We just explain
its behaviour for this example here, and give the precise syntax and
semantics of such interpreted Lucky automaton later.



\begin{figure}[th]
  \begin{center}
    \rule{14cm}{1pt} \vspace{1cm}
    
%\vspace{-2cm}
  \mbox{{\input{heater_sensors.tex}}}
  
  \end{center}
$init = (cpt = 0) \wedge (T=15.0) \wedge (t1=T)  \wedge (t2=T)  \wedge (t3=T) $

$always = (-0.1 \leq \eps1 \leq 0.1) \wedge (-0.1 \leq \eps2 \leq 0.1)  \wedge (-0.1 \leq \eps3 < 0.1) $

$ \ \ \ \ \ \ \ \ \ \ \ \ \ \wedge \  (cpt = pre \ cpt + 1) \wedge (T = pre T + (if \ On \ then \ 0.2 \ else \ -0.2))$


$ok3 = always \wedge  (t1= T +\eps1) \wedge (t2= T +\eps2) \wedge (t3= T +\eps3)$ 
 
$ok2 = always \wedge (t1= T +\eps1) \wedge (t2= T +\eps2) \wedge (t3 = pre \ t3) $


$ok1 = always \wedge (t1= T+\eps1) \wedge (t2 = pre \ t2) \wedge (t3 = pre \ t3) $

$ok0 = always \wedge (t1 = pre \ t1) \wedge \wedge (t2 = pre \ t2) \wedge (t3 = pre \ t3)$

\begin{center}
  \rule{14cm}{1pt}
\end{center}

  \caption{A possible  environment for a heater controller
%    inputs={On} ; locals={T} ; outputs={t1, t2, t3}
 \label{heater-sensors} }

\end{figure}


The Lucky automaton of Figure~\ref{heater-sensors} environment is
non-deterministic machine which:
\begin{itemize}
\item 1 input variable (the output of the SUT): the Boolean $On$,
  which is true iff the heater heats;
\item 2 local variables: the real $T$, representing the perfect
  temperature in the room, and the integer $cpt$ that will be used as
  a counter;
\item and 3 output variables (the inputs of the SUT): the reals $t1$,
  $t2$, and $t3$, which contain perturbated version of $T$ .
\end{itemize}

The initial node is the one labelled by $1$.  The output values for
the first instant are given by the $init$ equation that labels the
transition from node 1 to node 2. It states that outputs $t1$, $t2$,
and $t3$, are set to $15.0$, and the local counter $cpt$ is set to
$0$. 

The values for the second instant will be computed via one of the 2
transitions outgoing from node 2: one is labelled by $10000$, and the
other one by the integer counter $pre \ cpt$. The meaning of those
integers is the following: use the first transition with a
probability of $\frac{10000}{10000+pre \ cpt}$ and the second one
with a probability of $\frac{pre \ cpt}{10000+pre \ cpt}$.  At second
instant, since $pre \ cpt$ is bound to $0$, the only possible
transition is the one labelled by $ok3$.  $ok3$ states that, if On is
true, then $T$ is incremented of $0.2$, and if it is false, it is
decremented of $0.2$; the perturbations $\eps1$, $\eps2$, and $\eps3$
are randomly drawn between $-0.1$ and $0.1$; $t1$, $t2$, and $t3$
are set to $T$ plus $\eps1$, $\eps2$, and $\eps3$ respectively;
the counter $cpt$ is incremented.

At the third instant, the situation is roughly the same, except that
the transition from node 2 to node 3 is now possible, with a
probability of $\frac{1}{10001}$. If this transition is taken, the
output and local variables will be computed by the formula $ok2$,
which is basically the same as $ok3$, except that one sensor ($t3$)
is broken: it keeps its previous value whatever the temperature $T$
is. Note that as time flies, the probability to go to the node 3
increases; this somehow models that the probability of failures increases
with time.

For the following instants, the Lucky automaton behaves similarly:
$ok1$ encodes a situation where only 1 sensor is working correctly, 
and $ok0$ encodes a situation where no sensors are working.


A sensible oracle for that controller could be a Lustre program that
checks that when the heater in $On$, the temperature increases, and
when it is not, the temperature decreases. This assertion is of
course very likely to be violated when the current node of the
environment is node 5, namely, when no sensor works correctly.






%---------------------------------------------------------------------
%---------------------------------------------------------------------
%---------------------------------------------------------------------
%---------------------------------------------------------------------
%---------------------------------------------------------------------
%---------------------------------------------------------------------
\newpage

% \section{Architecture of the tool}

\section{Lurette Architecture -- Components Description}
\label{lurette-components}



In this Section, we present the different tools, resource files and
libraries that are involved in the production of the final
executable that will perform the testing. We also describe how the
SUT, the test Oracle, and the SUT environment will be connected one
to each other.



\subsection{Interfacing Lurette with the SUT} 
\label{sut-interface}

In order to run the test, as far as the SUT is concerned, Lurette
needs to be able to:
\begin{enumerate}
\item read/write its input/output (\code{read\_o} and \code{write\_i});
\item perform a try, namely, to have a mean to save and restore the
  SUT state (\code{try}).
\item perform a step (\code{step});
\end{enumerate}



The two languages we plan to support are the academic Lustre
(Verimag), and Scade (Esterel-Technologies). Both compiles into C
code, but with distinct interfaces in the way the 4 interfaces
functions (\code{read\_o}, \code{write\_i}, \code{step} and
\code{try}) are to be performed. Moreover, Lurette should be able to
be used to test any reactive system code, for which compilers would
certainly have (similar but) different interfaces. For that reason,
the calls to the SUT interface functions should not be hard-coded:
Lurette ought  to call an abstract interface, that will need to be
implemented for each different SUT code compiler. 

\begin{figure}[h]
  \scalebox{0.7}{\input{objs/obj-code-gen}}
%  \epsfig{figure=obj-code-gen.eps, width=13cm}
  \caption{Object Code Generation for the SUT}
  \label{obj-code-gen}
\end{figure}

The implementation of this abstract interface for the Lustre and the
Scade compilers is materialised in Figure~\ref{obj-code-gen} by the
\term{gen\_stubs\_lustre} and \term{gen\_stubs\_scade} tools.  The
generated C code is parsed in order to retrieve the input and output
variable names and types.  The generated file \verb+sut_stubs.c+
implements the abstract interface that provides to
\term{LURETTE\_EXE} the interface functions \code{read\_o},
\code{write\_i}, \code{step} and \code{try}.

Figure~\ref{obj-code-gen} also makes explicit the usual Lustre /
Scade code compilation process into c (\code{lustre2c} /
\code{Scade2c}), and the object code generation with a C compiler
(\code{cc}).


\subsection{Interfacing Lurette with the Oracle} 
\label{oracle-interface}
In the current scheme, the oracle is written in the same language as
the SUT (Lustre or Scade). Therefore, the interfacing work is exactly
the same as for the SUT.


\subsection{Interfacing Lurette with the Environment simulator}
\label{lucky-interface} 
The main part of the Lurette implementation effort lies in the Lucky
programs simulation.  At this level of the description, we only focus
on the description of the connection between components; we therefore
suppose that we have \code{read\_o}, \code{write\_i}, \code{step} and
\code{try} functions for the environment too. The description of
their implementation is done in Section~\ref{lucky-interfaces}.


An outline of the different components involved in the final
executable file \term{LURETTE\_EXE} is provided in
Figure~\ref{components-diagram}. The object code files \code{sut.o}
and \code{sut\_stubs.o} (cf~\ref{sut-interface}) as well as
\code{oracle.o} and \code{oracle\_stubs.o}(cf~\ref{oracle-interface})
are linked the Lucky ({\tt \green env.luc}) file interpreter library
\code{lucky\_lib.a}.

Note the \code{lucky\_lib.a} uses two external libraries: A Binary
Decision Diagram library (\code{bdd.a}) to deals with Boolean
variables; and a convex Polyhedron Library (\code{polyhedron.a}) to
deal with numeric variables.
 
Lurette also needs to read (via a GUI) the {\green Test Parameters}
(cf Section~\ref{test-parameters}).


\begin{figure}[h]
  \scalebox{0.65}{\input{objs/components-diagram}}
  \caption{Lurette Components diagram}
  \label{components-diagram}
\end{figure}



%---------------------------------------------------------------------
%---------------------------------------------------------------------
\newpage
\section{Module interfaces and dependencies}
\label{lucky-interfaces}



\input{lurette-modules-summary}



%---------------------------------------------------------------------
%---------------------------------------------------------------------
%---------------------------------------------------------------------
%---------------------------------------------------------------------
\newpage
\appendix

\section*{Appendices}

\section{Module  interfaces and dependencies: Detailed Specification}
\label{lurette-detailled}

We provide in this Appendix of more detailed description
of  the Lurette module interfaces. It is somehow a more
refined version of Section~\ref{lucky-interfaces}. 

Types and functions signatures are given using the \emph{ocaml}
syntax, as modules will be implemented in ocaml.  Actually, the rest
of that Section was automatically extracted from ocaml interface
({\tt .mli}) files.

We recall here the ocaml type and module conventions that are used in
the following.  {\tt \color{DarkSlateGrey} val f : a -> b -> c}
declares a function {\tt f} which takes as inputs an element of type
{\tt \color{DarkSlateGrey} a}, and an element of type {\tt
  \color{DarkSlateGrey} b}, and which returns an element of type {\tt
  \color{DarkSlateGrey} c}. The type definition {\tt
  \color{DarkSlateGrey} type foo = (a' * int) list} states that the
type {\tt \color{DarkSlateGrey} foo} is a list of pairs; {\tt
  \color{DarkSlateGrey} 'a} is a type variable and therefore stands
for any type.  Inside the scope of a module (say {\tt
  \color{DarkSlateGrey} Foo}), the module qualifier can be omitted
(i.e., {\tt \color{DarkSlateGrey} t} stands for {\tt
  \color{DarkSlateGrey} Foo.t} in the scope of module {\tt
  \color{DarkSlateGrey} Foo}). The ocaml pre-defined type {\tt
  \color{DarkSlateGrey} 'a option} (which used quite often in the
sequel) definition is {\tt \color{DarkSlateGrey} None | Some of 'a}.


\input{lurette-modules}


%---------------------------------------------------------------------
%---------------------------------------------------------------------
\newpage

\section{The Lucky language specification}
\label{lucky-section}

% \subsection{Introduction}

A reactive system is an automated system that indefinitely responds
to its environment. We are particularly interested here in control
and embedded applications, where the environment is often the
physical world.  During the development of such systems,
non-determinism is often useful, for describing a partially designed
system and/or its environment.




\subsection{Overview}
We propose a model where a basic qualitative model describing a set of
behaviours is extended with a probabilistic mechanism.
The main features of this model are presented here.
\vspace{-4mm}
\paragraph{\bf Symbolic state/transition systems.}
The basic qualitative model consists in a very general
state/transition system, characterised by: 
\vspace{-3mm}
\begin{itemize}
\item a memory: a finite set of variables with no special
restrictions on their domains (to simplify, we will consider here just
Boolean, integer and rational values);
\item an interface: variables are declared as inputs, outputs,
or locals;
\item a finite control structure: an interpreted finite automaton, whose
transitions are representing reactions of the machine. 
\end{itemize}
\vspace{-3mm}
A global state of the system is then a pair made of the current
control point in the automaton (the {\em control-state}), and a current
valuation of its memory (the {\em data-state}).
Therefore the set of global states is potentially infinite.
\vspace{-3mm}
\paragraph{\bf Synchronous relations.}
We adopt the synchronous approach for the reactions:
all values in the memory are changing simultaneously when a reaction
is performed.  The previous value of the memory corresponds to the source data-state,
and the current value to the next data-state.
The transitions are labelled with information denoting what are the
possible values of the current memory depending on the current data-state.
This information is quite general: it is a {\em relation} between the
past and current values of the variables.  In particular, no distinction is made
between uncontrollable and controllable variables.
Performing a reaction will consist in finding solutions to such a  formula.
This problem induces a restriction: we suppose that, once
reduced according to the past and input values, the constraints are solvable
by some actual procedure\footnote{concretely, we have developed
a constraint solver for mixed Boolean/linear constraints.}.
%\vspace{-3mm}
\paragraph{\bf Weights instead of probabilistic distribution.}
The problem of adding probabilities to state/transitions systems has
been largely studied \cite{Rabin63,GlabbeekSS1995}. Some variants exist,
depending on how the choice of the action (in our case the data-state)
and the choice of the next control-state are related. According to the terminology of
\cite{GlabbeekSS1995}, our approach is close to {\em Generative Models},
where the probabilistic mechanism includes both the action and
the next-state choice.

Since we have to deal with uncontrollable variables, defining a sound notion
of distribution is quite complex: depending on those variables, a formula
may be infeasible, and thus its actual probability is zero.
In other terms, if we want to use probabilistic distributions, we have to
define a reaction as a map from
the tuple  (source state, past values, input values) to a distribution 
over the pairs (controllable values, next state).
Expressing and exploiting this kind of model
would be too complex. We prefer a pragmatic approach where probabilities
are introduced in a more symbolic way.

The main idea is to keep the distinction between the probabilistic information and 
the constraint information. Since constraints are influencing probabilities
(zero or non-zero), this information does not express the probability to be drawn, but 
pragmatically, the probability to be {\em tried}.
In order to emphasise the difference, we do not use distributions 
(i.e., set of positive values the sum of which is 1) but {\em relative weights}.
A relative weight is a positive rational value, not necessarily less than one,
the meaning of which is only defined relatively to another weight: if two 
possible reactions (i.e., the corresponding constraints are both satisfiable)
are labelled respectively with the weights $w$ and $w'$, then
the probability to perform the former is $w/w'$ times the probability
to perform the latter.
\vspace{-3mm}
\paragraph{\bf Static weights versus dynamic weights.}
The simplest solution is to define weights as constants,
but in this case, the expressive power is much weaker than the one of 
Generative Models.
In this simple case, the uncontrollable 
variables qualitatively influence the probabilities (zero or not, depending on the
constraints) but not quantitatively: the idea is then 
to define {\em dynamic weights} as numerical functions of 
the inputs and the past-values.
Taking numerical past-values into account can be particularly useful:
a good example is when simulating
an {\em alive process} where the system has a known average life expectancy before
breaking down; at each reaction, the probability to work properly
depends {\em numerically} on an internal counter of the process age.
\vspace{-3mm}
\paragraph{\bf Transient states.}
For the time being, we have only one notion of state:
a state is a stable control point, and a transition
between two states defines an atomic reaction.
However, we think it may be convenient to introduce
the notion of {\em transient state}, and, as a consequence
a notion of micro-step: a complete reaction
is then a sequence of transitions between two stable states, where
all the intermediate states are transient.
Transient states do not affect the synchronous 
interpretation of the variable changes: intuitively,
if we abstract probabilities, a reaction
$q \transition{f}{} t \transition{g}{} q'$, is
qualitatively equivalent to $q \transition{f \wedge g}{}$.
In contrast, transient states affect probabilities, 
and may be helpful to express complex conditional relative weights.
\vspace{-3mm}
\paragraph{\bf Global concurrency.}
Concurrency (i.e., parallel execution) is a central paradigm for
reactive systems. The problem of merging sequential and parallel constructs
has been largely studied: classical solutions are hierarchical automata
``\`a la StateCharts'' \cite{maraninchi92,syncchart96}, or statement-based
languages like Esterel~\cite{esterel:scp}.
Our opinion is that deeply merging sequence and parallelism is a problem of
high-level language, and that it is sufficient to have a notion of global
parallelism: intuitively, local parallelism can always be made global
by adding extra idle states.
As a consequence, concurrency is a top level notion in our model:
a complete system is a set of concurrent automata, each one producing
its own constraints on the resulting global behaviour.
   \newcommand{\A}{\mbox{$A/a$}}
   \newcommand{\B}{\mbox{$B$}}
   \newcommand{\X}{\mbox{$X/x$}}
   \newcommand{\Y}{\mbox{$Y$}}
   \newcommand{\AY}{\mbox{$A\wedge Y/a$}}
   \newcommand{\BX}{\mbox{$B\wedge X/x$}}
   \newcommand{\BY}{\mbox{$B\wedge Y$}}
   \begin{figure}[t]
   \begin{center}
   \scalebox{0.7}{\input{objs/para}}
   \caption{Weights and parallelism: the parallel composition (\ref{para}a),
   and, assuming that $A \wedge X$ is infeasible, the product solution (\ref{para}b)
   and the arbiter solution (\ref{para}c).}
   \label{para}
        \vspace{-8mm}
   \end{center}
   \end{figure}
\vspace{-3mm}
\paragraph{\bf Weights and parallelism.}
In terms of control structures, parallelism corresponds to 
a kind of synchronous product of automata. Transient states
make this ``product''  more complex than a simple Cartesian product,
but do not involve big difficulties. For formulas, the product is simply
the logical ``\emph{and}''.
Unfortunately, there is no obvious way for combining stochastic information:
as they are defined, they are only local information and they may
induce paradoxes when combined into a parallel composition.
A simple example is shown in Figure~\ref{para}a: the first automaton (resp. the second)
has the choice between the constraints $A$ or $B$ (resp. $X$ or $Y$) both
satisfiable. In the first automaton, the choice of $A$ has a big weight
$a>>1$ compared to $B$ (1 by default), and in the second one, $X$ has a big
weight $x>>1$ comparing to $Y$.
Suppose that the data-state makes it impossible to satisfy $A \wedge X$,
it follows that it is impossible to satisfy the stochastic demand of both
components.
There is mainly two ways to solve the problem:
\vspace{-2mm}
\begin{itemize}
\item Consider that weights are not only local information, but are also 
influencing the parallel composition: for instance, if $a$ is much bigger than 
$x$, that means that the stochastic demand of the first component is much stronger
than the one of the second. The simplest way to implement this notion is to
combine weights with multiplication, as shown in Figure~\ref{para}b. 
\item The problem is treated at the parallel composition level, where
some indications are added to express priority for satisfying stochastic demands.
Intuitively, the components of a parallel composition are treated
sequentially: the first one is perfectly served, according to its own
local weights, then the second is served according to what was decided by the
first one, etc. The order of components is, in general non-deterministic, and
stochastic information may be added to influence it. 
The Figure~\ref{para}c shows a product where
a first fair choice is made to decide which component will ``play'' first
(note that all intermediate states are transient).
\end{itemize}
\vspace{-3mm}
There is no obvious argument to prefer one solution to another: both are 
consistent, and none is clearly more natural than the other.
As a consequence, 
%we have adopted a pragmatic approach:
both are implemented and the user can choose between them. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% LUCKY
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\newcommand{\integer}{\mathbb{N}}
\newcommand{\relative}{\mathbb{Z}}
\newcommand{\rat}{ \mathbb{Q} }
\newcommand{\boolean}{ \mathbb{B} }

%\paragraph{Variables, types, valuations and formula.}
\subsection*{Details}

%\paragraph{Data structures}
%~
\newcommand{\FS}{\mbox{$\cal F$}} \newcommand{\Wgt}{\mbox{$\cal W$}}
%\newcommand{\prev}{\mbox{\ominus}}
\vspace{-3mm}
\paragraph{Variables.}
\label{lucky-vars}
\USMM\ variables are either \emph{input}, \emph{output}, \emph{local},
or \emph{previous}: $V = V_i \uplus V_o \uplus V_l \uplus V_p$.
The previous variables are meant to refer to previous values of
the other variables in $V_{\setminus p} = V_i \uplus V_o \uplus V_l$.
Each previous variable is denoted by $\pre v$ where $v \in V_{\setminus p}$. 
Moreover, each variable in $V_{\setminus p}$ is defined with a default value:
the value just before the first reaction.
Local variables can be seen
as output variables that are hidden from the outside.
The typing function, $Type : V \rightarrow \{\boolean, \relative,
\rat\}$ associates a definition domain with each variable: Boolean,
integer or rational; obviously, $Type(v) = Type(\pre v)$.
%Output and local variables are called the \emph{controllable variables}.  

For the sake of (formula) conciseness, we also introduce a concept of
\emph{mode} attached to controllable variables: in the \emph{stable mode},
unconstrained variables are bound to their previous value; in
the \emph{unstable mode}, unconstrained variables are drawn from
their definition domain (this is to avoid boring repetitions of {\tt
$v = \pre v$} statements).

\vspace{-3mm}
\paragraph{Valuations.}
A \emph{valuation}
%$\sigma \in \Sigma = \Sigma_i \times \Sigma_o \times \Sigma_l \times \Sigma_p : V \rightarrow Type(V)$
is a mapping from variables to values.
%
A \emph{data-context} is a pair $(\sigma_i, \sigma_p)$, where
$\sigma_i$ (input valuation) associates a value with each input,
and $\sigma_p$ (previous valuation) associates a value
with each previous variable. Previous valuations are also called
{\em data-state}. In particular, the default values of
variables are defining the {\em initial data-state}, denoted by
$\sigma_p^0$.

\vspace{-3mm}
\paragraph{Formula.} A formula is any well-typed Boolean expression 
made of variables, constants, and classic
logical and numerical operators
({$\scriptstyle \neg, \wedge, \vee, =, >, <, \ge, \le, +, -, *, /$}).
We note $\FS$ the set of well-typed formula.

Given a data-context, any formula can be reduced to a formula over
the controllable variables ($V_o \uplus V_l$). The
notation \mbox{$(\sigma_i, \sigma_p): (\sigma_o, \sigma_l) \models f$}
states that, given a context $(\sigma_i, \sigma_p)$, the
controllable valuation $(\sigma_o, \sigma_l)$ satisfies $f$.

 
%\paragraph{States, transitions, constraints and weights.}
\vspace{-3mm}
\paragraph{Control structure}

At the top level, the behaviour of a system is described by a non-empty set 
of concurrent \WTS\ sharing the same variables.
Each \WTS\ is an interpreted automaton, where transitions are labelled
by qualitative and stochastic constraints, as presented in the sequel.

\vspace{-3mm}
\paragraph{Nodes (or control states).}
The set of \emph{control-states}, is divided into
\emph{stable} states and \emph{transient} states: $Q = Q_s \uplus
Q_t$. The initial control state is a particular stable state $q^0
\in Q_s$.

\vspace{-3mm}
\paragraph{Weights.}
Weights  are positive numerical functions of the
uncontrollable variables:
$\Wgt: \Sigma_i \times \Sigma_p \rightarrow \rat \cup \{\infty\}$.
More concretely, they are given as numerical expressions made of inputs,
previous variables, classical operators or ad hoc computable functions. 
The $\infty$ value is introduced to express a sound notion of mandatory
choice: a transition with the infinite weight has priority on any
finite weighted transition. There is a single notion 
of infinite weight: two feasible transitions with infinite
weight have the same probability.
%If one wants to express relative probabilities
%between several mandatory choices, he must use transient states to detail
%the control structure.
In order to express relative probabilities between 
mandatory choices, it is necessary to detail 
the control structure by introducing transient states.

\vspace{-3mm}
\paragraph{Transitions.}
The set of transitions is a relation:
$T \subseteq Q \times \FS \times \Wgt \times Q$,
and we note $q \transition{f}{w} q' \in T$ a transition from $q$
to $q'$ labelled by the formula $f$ and the weight $w$.  

\vspace{-3mm}
\paragraph{Transitional loops.}
We do not try to give sense to infinite loops of transient states:
models containing such combinational loops are statically rejected.
 
\subsection{Operational  Semantics}
%\subsubsection{Simulation algorithm}

The \USMM\ are defined in such a way that their operational semantics
is straightforward. In some sense, they are {\em executable} by
definition. We give here the main lines of the simulation
algorithm.

\vspace{-3mm}
\paragraph{\bf Product.}
First of all, the behaviour which is in general expressed as a a set of
concurrent automata, is semantically equivalent to the one of
a single {\em product automaton}. Two different products are
defined, depending on the semantics chosen for weights composition
(Figure~\ref{para}).
The simplest one is almost a classical {\em synchronous product}:
\begin{itemize}
\item the global state space is the Cartesian product of the 
component state spaces;
the global initial state is the tuple of initial states;
a global state is stable if it is composed of stable states only.
\item the definition of global transitions is almost a classical
composition where constraints are combined with the $\wedge$ operator,
and weights with the $*$ operator. The only problem is to
enforce the synchronisation on stable states; 
we note $s_1,s_2$ stable states,
$t_1,t_2$ transient states and $q_1,q_2$ any states, so:
\begin{itemize}
\item $(s_1, s_2)\transition{f_1 \wedge f_2}{w_1 * w_2}(q_1, q_2)$ iff
$s_1\transition{f_1}{w_1}(q_1)$ and 
$s_2\transition{f_2}{w_2}(q_2)$
\item $(t_1, t_2)\transition{f_1 \wedge f_2}{w_1 * w_2}(q_1, q_2)$ iff
$t_1\transition{f_1}{w_1}(q_1)$ and 
$t_2\transition{f_2}{w_2}(q_2)$
\item $(s_1, t_2)\transition{f_2}{w_2}(s_1, q_2)$ iff
$t_2\transition{f_2}{w_2}(q_2)$, and symmetrically for $(t_1,s_2)$.
\end{itemize}
\end{itemize}

The second kind of ``product'' (as shown in Figure~\ref{para}c) is a
little bit tricky: the idea is to 
introduce, for each component, an additional {\em starting} transient state
$\hat{s}$ and an additional {\em waiting} transient state $\breve{s}$ 
for each stable state $s$. 
The global state space is then defined as the Cartesian 
product over the extended component state spaces.
The definition of initial and stable global states does not change.
The transitions are defined in such a way that each component 
performs its reaction in turn. We only give the rules where the first component
starts, the other case is similar:
\begin{itemize}
\item from a global stable state, the first
component may start while the other waits:
$(s_1, s_2)\transition{~}{~}(\hat{s}_1,\breve{s}_2)$, 
\item the starting component performs its first transition:\\
$(\hat{s}_1, \breve{s}_2)\transition{f_1}{w_1}(q_1,\breve{s}_2)$ 
iff $s_1\transition{f_1}{w_1}q_1$, 
\item the starting component is not yet in a stable state, and it performs
another transition: $(t_1, \breve{s}_2)\transition{f_1}{w_1}(q_1,\breve{s}_2)$ 
iff $t_1\transition{f_1}{w_1}q_1$,
\item the starting component has reached a stable state, and
the waiting one starts its reaction:
$(s_1, \breve{s}_2)\transition{f_2}{w_2}(s_1,q_2)$ 
iff $s_2\transition{f_2}{w_2}q_2$,
\item the second component performs transitions until it reaches
a stable state: $(s_1, t_2)\transition{f_2}{w_2}(s_1,q_2)$ 
iff $t_2\transition{f_2}{w_2}q_2$.
\end{itemize}

In the sequel, we suppose that we have a single automaton,
obtained with one of the product operations defined above.
Note that, in the concrete implementation, the global product is
not statically built: local products are simply build {\em on the fly}
to avoid space state explosion.

\vspace{-3mm}
\paragraph{\bf Execution.}
A \emph{Lucky program execution}, according to 
a given input history $(\nu^n)_{n \geq 0}$
is a sequence of pairs made of a stable 
state and a valuation: $(s^n, \sigma^n)_{n \geq 0} \in \integer
\rightarrow Q_s \times \Sigma$, such that:
\begin{itemize}
\item $s^0$ is the initial control state and $\sigma^0_p$ is the default
map of the variables,
\end{itemize}
\vspace{-2mm}
and for each $k$:
\vspace{-2mm}
\begin{itemize}
\item $\sigma^k_i = \nu^k$ (the valuation history meets the input history) 
\item $\sigma^{k}_{\setminus p} = \sigma^{k+1}_p$
(the current-part of the valuation meets the previous-part of the next
valuation)
\item $(s^k,\sigma^k_p,\sigma^k_i) \simpletrans{\sigma^k_o,\sigma^k_l} s^{k+1}$
is a feasible, fair reaction according to the control structure. We detail
in the sequel the algorithm for finding such a reaction.
\end{itemize}
\newcommand{\WF}{\mbox{$w$}}
\newcommand{\FF}{\mbox{$f$}}

\vspace{-6mm}
\paragraph{\bf Reaction.}
Intuitively, a step in an execution is done by drawing, according to
weight directives and current values of uncontrollable
variables, a path in the automaton from the current
(stable) state to a next stable state.
More formally, let $s = q_0$ be the current control-state,
$\sigma_p$ the current data-state and $\sigma_i$ the current inputs.
For all $k$, we note $\Theta_k = \{ q_k \transition{f}{w} q\}$ the
set of transitions leaving $q_k$, and we use the notation
$\WF_\tau$ to denote the weight attached to a transition $\tau$.
According to the current data context, the sum of weights
$W_k = \sum_{\tau \in \Theta_k} \WF_\tau(\sigma_p,\sigma_i)$ is
a numerical constant. 
If there exist some transition $\tau$ from $q_k$ to $q_{k+1}$,
the probability to complete a path $(q_0, q_1, ..., q_k)$ with $q_{k+1}$ 
is then: $\WF_\tau(\sigma_p,\sigma_i) / W_k$.
This process is repeated until a stable node $q_n = s'$ is reached:
$s \transition{f_1}{w_1} q_1 \transition{f_2}{w_2} q_2 \cdots
q_{n-1} \transition{f_n}{w_n} s'$, where all
$q_1, \cdots q_{n-1}$ are transient.

The conjunction of all formulas labelling the drawn path is the
elected formula: $f={\overset{n}{\underset{k=1}{\wedge}}} f_k$.
We substitute in $f$ input and previous variables ($f_{|\sigma_i
  \sigma_p}$), and solve it. A valuation of output and local
variables for the current step is obtained by performing a fair toss
among the solutions of that formula.
If $f_{|\sigma_i \sigma_p}$ is unsatisfiable, another path is drawn.
If no satisfiable path can be drawn, the machine stops.

As it is presented, this algorithm is quite ineffective, and,
moreover it may diverge if no particular precaution is taken to avoid
trying several times the same infeasible path.  Infeasible paths
should be detected as soon as possible (it suffices to mark nodes) to
avoid divergence.


%--------------------------------------------------------------------

\subsection{A Lucky program Example}
\label{Example}

We illustrate its use on an example of Figure~\ref{windows-ex}.


\begin{wrapfigure}{r}{7cm}
%\vspace{-2cm}
\scalebox{0.9}{\input{objs/windows}}

 $V_i=\{ On, T \}$,
 $V_o=\{ t \}$,
 $V_l=\{ \delta, \cpt \}$,
 $V_p=\{ \pre t, \pre \cpt \}$,
 $Q_s = \{ \mathit{S_{on}}, \mathit{S_{off}}, \mathit{S_{open}} \}$,
 $q_0 = \mathit{S_{on}}$.
%\vspace{-8mm}
\label{window-automata}
\caption{A Lucky program that simulates the temperature in a room with a heater and a window.}
  \label{windows-ex}

\end{wrapfigure}

The automata of Figure~\ref{window-automata} represents a Lucky program
that models the temperature in a room containing a heater and a
window which is opened from times to times.  The version of this
automaton given in Lucky concrete syntax is provided in
Figure~\ref{windows-lucky}.  Input variables are a Boolean $On$,
which is true if the heater in on, and a real $T$, which indicates
the temperature outside the room.
%
The only output variable is a real $t$, indicating the
temperature inside the room.
%
Local variables are the real $\delta$, which is used to compute
the new temperature, and the integer $\cpt$, which is used to count
the number of steps the window remains open.
% 
Previous variables are $\pre t$ and $\pre \cpt$.
%
Stable states are denoted by $\mathit{s_{on}}$, $\mathit{s_{off}}$, and
$\mathit{s_{open}}$. The other unnamed states are transient. 
The initial node is $\mathit{s_{on}}$.  

If the heater is Initially on (resp. off), only 2 transitions are
possible among the 3 output transitions of $\mathit{s_{on}}$,
since the transition labelled by $\neg On$ (resp. $On$) is unsatisfiable.
The first possible transition has weight 100, and the other one has
weight 1.
\begin{itemize}
\item The first transition will therefore be drawn with a probability
  of $100/101$. It leads to a transient state which has only one
  output transition leading back to $\mathit{s_{on}}$ (resp.
  $\mathit{s_{off}}$); the elected formula is therefore $0<\delta<0.2
  \wedge t=\pre t + \delta$. It states that the local variable
  $\delta$ will be uniformly drawn between $0$ and $0.2$ (resp.
  $-0.1$ and 0), and that $\delta$ is then used to increase the
  temperature.  This is intended to model that, when the heater is on
  (resp. off), the temperature slightly increases (resp. decreases).
\item The second transition will be drawn with a probability of
  $1/101$. After two transient states, the only stable
  node that is reachable is $\mathit{s_{open}}$, and the
  elected formula is therefore $true \wedge 10 \leq \cpt \leq 15 \wedge
  t=\frac{3 \pre t + T}{4}$.  It states that the local integer
  variable \cpt\ is drawn uniformly between 10 and 15, and defines
  how the new temperature is computed.  This is intended to model
  that, whenever the window is open, the temperature becomes closer
  from the temperature outside.
  
  For the next step, from $\mathit{s_{open}}$, 3 transitions are
  possible, but they are labelled by formulas that can not be true at
  the same time (they form a partition): as long as \cpt\ is
  greater than 0, the window will remain open; \cpt\ is
  decremented at each step, and when it reaches 0, the control 
  gets back to either $\mathit{s_{on}}$ or $\mathit{s_{off}}$, depending
  on the variable $On$.
\end{itemize}
 

\begin{figure}
\begin{bigbox}
% types        = 
\begin{verbatim}
inputs  { T: float; On: bool }
outputs { t: float }
locals {  delta: float ~min -10.0 ~max 10.0;
          j: int ~init 0 ~min 0 ~max 20 ~default 0 }

nodes {
  s_init :stable; s_on : stable; s_off : stable; s_open : stable;
  init : transient; 
  t1 : transient;  t2 : transient; t3 : transient;  t4 : transient  }
start_node { init }

transitions {  
     init   -> s_init         ~cond t = 17.0;
     s_init -> t1             ~cond On;
     s_init -> t2             ~cond not On;
     s_on   -> t1 ~weight 100 ~cond On; 
     s_on   -> t2 ~weight 100 ~cond not On; 
     s_on   -> t3;
     s_off  -> t1 ~weight 100 ~cond On; 
     s_off  -> t2 ~weight 100 ~cond not On; 
     s_off  -> t3;

     t1 -> s_on   ~cond  0.0 < delta and delta < 0.5 
                        and t = pre t + delta;
     t2 -> s_off  ~cond -0.5 < delta and delta < 0.0 
                        and t = pre t + delta;
     t3 -> t4     ~cond (10 <= j) and (j <= 15) ;
     t4 -> s_open ~cond t = (3.0 * (pre t) + T) / 4.0 ;

     s_open -> t1  ~cond pre j = 0 and On ;
     s_open -> t2  ~cond pre j = 0 and not On; 
     s_open -> t4  ~cond pre j > 0 and j = (pre j) - 1;
   }
\end{verbatim}
\end{bigbox}
\caption{The Lucky program of Figure~\ref{windows-ex} in concrete syntax} 
\label{windows-lucky}
\end{figure}



%---------------------------------------------------------------------
%---------------------------------------------------------------------
\newpage
\input{lucky-syntax}








\newpage
\input{english.macros}
\bibliographystyle{alpha}
\bibliography{zebib}



\end{document}  


